#include "driverlib/timer.h"
#include <assert.h>

#define CPUT_BASE TIMER2
#define TIME TimerValueGet(CPUT_BASE, TIMER_A)
uint32_t elapsed = 0;

uint32_t timer_start_frame(void) {
	uint64_t ret = TIME;
	TimerEnable(CPUT_BASE, TIMER_A);
	TimerConfigure(CPUT_BASE, TIMER_CFG_ONE_SHOT_UP);
	TimerUpdateMode(CPUT_BASE, TIMER_A, TIMER_UP_LOAD_IMMEDIATE);
	TimerIntDisable(CPUT_BASE, -1);
	TimerLoadSet64(CPUT_BASE, TIMER_A, 0);
	return ret;
}

void timer_start(void) {
	elapsed = TIME;
	if (!elapsed)
		elapsed++;
}

uint32_t timer_elapsed(void) {
	uint32_t ret;
	assert(elapsed);
	ret = elapsed - TIME;
	elapsed = 0;
	return ret;
}

void delay(volatile uint32_t n) {
	while(--n);
}
	
void main(void) {
	while(1) {
		uint32_t el1, el2, total;
		
		timer_start();
		delay(2e6);
		el1 = timer_elapsed();
		delay(3e6);
		timer_start();
		delay(8e6);
		el1 = timer_elapsed();
		delay(1e6);
		total = timer_start_frame();
		printf ("el1=%u el2=%u total=%u\n");
		printf ("el1\t%.2d%%\n", el1 / total);
		printf ("el2\t%.2d%%\n", el1 / total);
	}
}
